% =========================================================================
%   Praktikum MATLAB/Simulink II
%   Technische Universitt Darmstadt
%   IAT, FG rtm (Prof. Dr.-Ing. U. Konigorski)
%
%   Copyright (c) 2017, FG Regelungstechnik und Mechatronik,
%                       Technische Universitt Darmstadt
%   All rights reserved.
%
%   Redistribution and use in source and binary forms, with or withou
%   modification, are permitted provided that the following conditions are
%   met:
%
%   1. Redistributions of source code must retain the above copyright
%      notice, this list of conditions and the following disclaimer.
%
%   2. Redistributions in binary form must reproduce the above copyright
%      notice, this list of conditions and the following disclaimer in the
%      documentation and/or other materials provided with the distribution.
%
%
%   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% =========================================================================

function plotResultsObs(vT, mX, mXobs, vU, vEigObs)

	figure();

	vhAxes(1) = subplot(3, 1, 1);
	vhAxes(2) = subplot(3, 1, 2);
	vhAxes(3) = subplot(3, 1, 3);

	axes(vhAxes(1));
	plot(vT, vU);
	ylabel('u(t)');
	title([ '\lambda_{obs} = [ ' num2str(vEigObs) ' ]' ]);

	axes(vhAxes(2));
	plot(vT, mX(:,1));
	ylabel('x(t)');

	axes(vhAxes(3));
	plot(vT, mX(:,3));
	ylabel('\phi(t)');
	xlabel('t [s]');

	linkaxes(vhAxes, 'x');
	
	
	figure;
	claLegend = {'x(t)', 'x_{obs}(t)'};
	szLocation = 'SouthEast';
	
	vhAxes2(1) = subplot(4,1,1);
	plot(vT, mX(:,1), ':', vT, mXobs(:,1), 'b');
	ylabel('x_1, x_{1,obs}')
	legend(claLegend, 'Location', szLocation);
	title([ '\lambda_{obs} = [ ' num2str(vEigObs) ' ]' ]);
	
	vhAxes2(2) = subplot(4,1,2);
	plot(vT, mX(:,2), ':', vT, mXobs(:,2), 'b');
	ylabel('x_2, x_{2,obs}')
	legend(claLegend, 'Location', szLocation);
	
	vhAxes2(3) = subplot(4,1,3);
	plot(vT, mX(:,3), ':', vT, mXobs(:,3), 'b');
	ylabel('x_3, x_{3,obs}')
	legend(claLegend, 'Location', szLocation);

	vhAxes2(4) = subplot(4,1,4);
	plot(vT, mX(:,4), ':', vT, mXobs(:,4), 'b');
	ylabel('x_4, x_{4,obs}')
	legend(claLegend, 'Location', szLocation);
	
	xlabel('t [s]')

	linkaxes(vhAxes2, 'x');
	
	
	

end % function plotResults